/*
	Fonctions gnriques appeler un peu partout
	De plus les fonctions se trouvant ici auront pour vocation d'tre utilis dans Freya
*/



/***
 * Cette fonctions sert  rcuprer l'objet navigateur
 */
function getBrowser() {
  	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  	const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
  	const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
  	const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
  	var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
  	var browser = browserWindow.getBrowser();
  	netscape.security.PrivilegeManager.revertPrivilege("UniversalXPConnect");
	return browser;
}


/***
 * C fonctions devront tre gnralises pour ensuite tre utilises dans 
 * Tous les autres projets Fani.
 * En parlant de gnralisation je parle de capacit de grer des valeurs de prferences
 * aussi bien en boolean, qu'en string ou en int
 */
function getValueOfPref(namePref) {
  	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);		
	/* necessite de verifier */
	var value = prefs.getBoolPref(namePref);
  	netscape.security.PrivilegeManager.revertPrivilege("UniversalXPConnect");
	return value;
}

function setValueOfPref(namePref, value) {
  	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);		
	var value = prefs.setBoolPref(namePref, value);
  	netscape.security.PrivilegeManager.revertPrivilege("UniversalXPConnect");
	return value;
}

/***
 * permet d'effacer les espaces non utiles, en attendant de trouver mieux
 */
function trim(str) {
	return str.replace(/^\s*|\s*$/g,"");
}


/***
 * Cette fonction va surement disparaitre car elle est surement dans la liste des mthodes
 * de la classe Array
 */
function alreadyInArray(where, what) {
	for (i = 0; i < where.length; i++) {
		if (where[i] == what)
			return true;
 	}
	return false;
}

/*
*Fonction servant a retourner le tab en fonction du navigateur
*/

function getTabulation(i,browser) {
	
	var browsername = navigator.userAgent

	if (browsername.search(/Firefox/) == -1)
		var ret =  browser.mPanelContainer.childNodes[i];
	else
		var ret =  browser.getBrowserAtIndex(i);
		
	return ret;
}


/***
 * Fonction servant a transformer la date en texte GMT
 */
function faniDate(pubDate) {
	var apubDate = new Date();
	apubDate.setTime(pubDate * 1000);
	return apubDate.toGMTString();
}

/***
*Fonction qui copie dans le presse papier
*/
function cpClipboard(text) {
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	
	var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	if (!str) return false;
	str.data = text;

	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	if (!trans) return false;

	trans.addDataFlavor("text/unicode");
	trans.setTransferData("text/unicode",str,text.length * 2);

	var clipid = Components.interfaces.nsIClipboard;
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
	if (!clip) return false;

	clip.setData(trans,null,clipid.kGlobalClipboard);

	netscape.security.PrivilegeManager.revertPrivilege("UniversalXPConnect");
}


/***
*Fonction permettant de faire des recherches XPath au sein d'une node
*/
function evaluateXPath(aNode, aExpr) {
  var xpe = new XPathEvaluator();
  var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ? aNode.documentElement : aNode.ownerDocument.documentElement);
  var result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
  var found = [];
  while (res = result.iterateNext())
    found.push(res);
  return found;
}
